/*###########################################################################
#                                                                           #
#               SPItbVt@CVXe							#
#                                                                           #
###########################################################################*/
#ifndef __FLASH_SYS_H__
#define __FLASH_SYS_H__

#include <avr/io.h>

/* t@C^Cv`				*/
typedef enum {
	FLASH_FS_FILE = 0 ,				/* ʏ̃t@C									*/
	FLASH_FS_IMAGE					/* C[Wt@C(16bit)							*/
} FLASH_FS_FILETYPE;

/* flashFsCopyFile() ֐̈ reserv ɓnp[^	*/
#define AUTO_RESERV 0				/* OȊO̒lɂĂ͂ȂȂ						*/

/* t@C\(32bytes)		*/
typedef struct FLASH_FS_INFO_t {
	char fname[13];					/* ]̃t@C(8.3`)						*/
	uint8_t ftype;					/* t@C^Cv FLASH_FS_FILE  / FLASH_FS_IMAGE	*/
	uint32_t fsize;					/* ۑĂt@CTCY						*/
	uint16_t topPage;				/* 擪y[Wԍ									*/
	uint16_t pageCount;				/* mۂĂy[W							*/
	uint16_t ftime;					/* ^CX^viԁj							*/
	uint16_t fdate;					/* ^CX^vitj							*/
	uint16_t bytesPerLine;			/* 1C̃oCg(ftype=FLASH_FS_IMAGE L)	*/
	uint16_t width;					/* 摜TCY(ftype=FLASH_FS_IMAGE L)		*/
	uint16_t height;				/* 摜cTCY(ftype=FLASH_FS_IMAGE L)		*/
} FLASH_FS_INFO;

/* FlashFS ubN			*/
typedef struct FLASH_FS_HEADER_t {
	char id[8];						/* ID "FLASH FS"							*/
	uint16_t indexMax;				/* ǗCfbNX								*/
	uint16_t nextPage;				/* 񊄂蓖ĂɎgpy[Wԍ					*/
	uint16_t freePages;				/* 󂫃y[W										*/
	uint16_t startDataPage;			/* 擪f[^y[Wԍ								*/
} FLASH_FS_HEADER;

/* BMPt@Cwb_\		*/
typedef struct BITMAPFILEHEADER_t {	/* size 14											*/
	uint16_t bfType;				/* t@C^Cv( "BM"\0x4d42 ) 				*/
	uint32_t bfSize;				/* t@CŜ̃TCY								*/
	uint16_t bfReserved1;			/* \(0)											*/
	uint16_t bfReserved2;			/* \(0)											*/
	uint32_t bfOffBits;				/* t@C̐擪sNZf[^܂ł̃oCg	*/
} BITMAPFILEHEADER;

typedef struct BITMAPINFOHEADER_t {	/* size 40											*/
	uint32_t biSize;				/* \̂̃TCY									*/
	uint32_t biWidth;				/* 摜̕											*/
	uint32_t biHeight;				/* 摜̍										*/
	uint16_t biPlanes;				/* v[(l͏1)							*/
	uint16_t biBitCount;			/* 1sNZ̃J[rbg(l1,4,8,16,24,32)*/
	uint32_t biCompression;			/* k^Cv(k:BI_RGB(0))						*/
	uint32_t biSizeImage;			/* sNZf[^̃oCg(bfSize-bfOffBits)		*/
	uint32_t biXPelsPerMeter;		/* 𑜓x										*/
	uint32_t biYPelsPerMeter;		/* 𑜓x										*/
	uint32_t biClrUsed;				/* gpJ[CfbNX(biBitCount16ȏȂ0)	*/
	uint32_t biClrImportant;		/* dvJ[CfbNX							*/
} BITMAPINFOHEADER;

/* ֐vg^Cv錾				*/
uint8_t flashFsFormat( void );
uint8_t flashFsCheckID( void );
uint16_t flashGetFree( void );
void flashFsGetIndex( uint16_t index ,FLASH_FS_INFO *info );
uint8_t flashFsCopyFile( uint16_t index ,FLASH_FS_FILETYPE ftype ,char *fname ,uint16_t reserv ,void (*func)(uint16_t,uint16_t) );
uint8_t flashFsGetBmpHeader( char *fname ,BITMAPFILEHEADER *bf ,BITMAPINFOHEADER *bi );
void vsLoadFlashCode( uint8_t index );

#endif
