/*###########################################################################
#                                                                           #
#      		         SPItbVt@CVXe					#
#																			#
###########################################################################*/
#define __FLASH_SYS_C__

#define WDT_MODE 1			/* 0:EIb`hbN 1:L					*/

#if (WDT_MODE)
#include <avr/wdt.h>
#endif

#include <string.h>
#include <avr/io.h>
#include "at45db161d.h"
#include "zy_fgd1442701v1.h"
#include "FatFs/tff.h"
#include "crc.h"
#include "vs1053b.h"
#include "flash_sys.h"

#define FSID "FLASH_FS"				/* t@CVXeID							*/
#define INDEX_COUNT 256				/* ǗCfbNX								*/
#define INDEX_PAGES 16				/* t@CCfbNẌy[W					*/
#define INDEXS_PER_PAGE 16			/* Py[W̃CfbNX					*/
#define HEADER_PAGE 0				/* t@CVXewb_y[Wԍ					*/
#define INDEX_PAGE 1				/* CfbNẌ擪y[Wԍ					*/
#define DATA_PAGE 17				/* f[^̈Jny[Wԍ							*/
#define LAST_PAGE 4079				/* ŏIy[Wԍ									*/

/* [J֐vg^Cv錾	*/
static void flashFsGetHeader( FLASH_FS_HEADER *hed );
static uint8_t flashFsPutHeader( FLASH_FS_HEADER *hed );
static uint8_t flashFsPutIndex( uint16_t index ,FLASH_FS_INFO *info );

/****************************************************************************
*						SPItbVtH[}bg
* Fvoid
* ߒlFuint8_t 0:OK  !0:NG
****************************************************************************/
uint8_t flashFsFormat( void )
{
	FLASH_FS_HEADER hed;
	uint8_t pageBuffer[512];						/* y[Wobt@	*/

	/* t@CVXewb_		*/
	memcpy_P( hed.id ,PSTR(FSID) ,8 );			/* ID					*/
	hed.indexMax = INDEX_COUNT;					/* ǗCfbNX		*/
	hed.startDataPage = DATA_PAGE;				/* f[^擪y[Wԍ		*/
	hed.nextPage = DATA_PAGE;					/* 񊄂蓖ăy[Wԍ	*/
	hed.freePages = LAST_PAGE - DATA_PAGE + 1;	/* 󂫃y[W		*/
	if ( flashFsPutHeader( &hed ) != 0 ) {
		return ( 1 );
	}

	/* CfbNẌNA			*/
	memset( pageBuffer ,0x00 ,512 );
	for ( uint16_t i = 0 ;i < INDEX_PAGES ;i++ ) {
		if ( flashWritePage( INDEX_PAGE + i ,pageBuffer ) != 0 ) {
			return ( 2 );
		}
	}

	return ( 0 );
}

/*****************************************************************************
*						ǗubNIDʕmF
* Fvoid
* ߒlFuint8_t 0:OK !0:NG
*****************************************************************************/
uint8_t flashFsCheckID( void )
{
	FLASH_FS_HEADER hed;

	flashFsGetHeader( &hed );
	if ( memcmp_P( hed.id ,PSTR(FSID) ,8 ) != 0 ) {
		return ( 1 );
	}

	return ( 0 );
}

/*****************************************************************************
*							󂫃ubN擾
* Fvoid
* ߒlFuint16_t ubN
*****************************************************************************/
uint16_t flashGetFree( void )
{
	FLASH_FS_HEADER hed;
	flashFsGetHeader( &hed );
	return ( hed.freePages );
}

/*****************************************************************************
*						t@CCfbNX擾
* Fuint16_t      index CfbNXԍ
*       FLASH_FS_INFO *info CfbNX
* ߒlFvoid
*****************************************************************************/
void flashFsGetIndex( uint16_t index ,FLASH_FS_INFO *info )
{
	uint16_t page;
	uint16_t offset;

	/* CfbNX擾			*/
	page = INDEX_PAGE + ( index / INDEXS_PER_PAGE );
	offset = ( index % INDEXS_PER_PAGE ) * sizeof(FLASH_FS_INFO);

	flashContinuousArrayRead( page ,offset );
	flashReadBLOCK( info ,sizeof( FLASH_FS_INFO ) );
	FLASH_DISABLE_CS();
}

/****************************************************************************
*				SDJ[h̃t@CSPItbV֓]
* Fuint16_t          index    t@CCfbNXԍ( 0 ` 255 )
*		FLASH_FS_FILETYPE ftype    FLASH_FS_FILE  : ʏt@C
*                                  FLASH_FS_IMAGE : R5G6B5`̃C[Wŕۑ
*		char              *fname   t@C
*		uint16_t          reserv   mۂy[W( AUTO_RESERV :  )
*		void (*func)(uint16_t,uint16_t) vOXo[\p̃R[obN֐
* ߒlFuint8_t                    0:OK !0:NG
* vOXo[́AC[Wt@Cǂݍݎ̂ݓ삷
****************************************************************************/
uint8_t flashFsCopyFile( uint16_t index ,FLASH_FS_FILETYPE ftype ,char *fname ,uint16_t reserv ,void (*func)(uint16_t,uint16_t) )
{
	FLASH_FS_HEADER hed;
	FIL fl;
	FILINFO filInfo;
	FLASH_FS_INFO flashInfo;
	BITMAPFILEHEADER bf;
	BITMAPINFOHEADER bi;

	uint8_t buf[8];
	uint8_t pageBuffer[512];						/* y[Wobt@	*/
	uint8_t *p;										/* y[W|C^	*/
	uint16_t page;									/* y[Wԍ		*/

	uint32_t usePages;
	uint16_t n;
	uint16_t bpc;
	uint16_t bpl;
	uint32_t fpos;
	uint16_t x ,y;
	uint8_t newFlag;

	/* t@CVXewb_擾					*/
	flashFsGetHeader( &hed );

	/* CfbNX擾							*/
	flashFsGetIndex( index ,&flashInfo );

	/* FatFst@C擾						*/
	if ( f_stat( fname ,&filInfo ) != FR_OK ) {
		return ( 1 );
	}

	/* CfbNX쐬							*/
	if ( flashInfo.fname[0] == 0x00 ) {
		newFlag = 1;
		memset( &flashInfo ,0x00 ,sizeof(FLASH_FS_INFO) );
	} else {
		newFlag = 0;
	}

	strcpy( flashInfo.fname ,filInfo.fname );			/* t@C						*/

	flashInfo.ftype = ftype;							/* t@C^Cv					*/

	flashInfo.fdate = filInfo.fdate;					/* ^CX^v					*/
	flashInfo.ftime = filInfo.ftime;

	if ( ftype == FLASH_FS_FILE ) {
		flashInfo.fsize = filInfo.fsize;				/* t@CTCY					*/

	} else {
		/* BMPwb_擾				*/
		if ( flashFsGetBmpHeader( fname ,&bf ,&bi ) != 0 ) {
			return ( 2 );
		}

		/* 摜p[^ݒ			*/
		flashInfo.width = (uint16_t)bi.biWidth;			/* 摜TCY()					*/
		flashInfo.height = (uint16_t)bi.biHeight;		/* 摜TCY(c)					*/
		flashInfo.bytesPerLine = (uint16_t)bi.biWidth * 2;		/* 1C̃oCg		*/
		flashInfo.fsize = bi.biHeight * (uint32_t)flashInfo.bytesPerLine;/* t@CTCY	*/
	}

	/* gpy[W`FbN				*/
	usePages = ( flashInfo.fsize + 511L ) / 512L;
	if ( newFlag ) {
		if ( usePages > (uint32_t)hed.freePages ) {		/* 󂫗̈s						*/
			return ( 3 );
		}

		flashInfo.pageCount = (uint16_t)usePages;
		if ( reserv != 0 ) {
			if ( flashInfo.pageCount > reserv ) {		/* \y[WɓȂ			*/
				return ( 4 );
			}
			flashInfo.pageCount = reserv;
		}

		flashInfo.topPage = hed.nextPage;				/* 擪y[Wԍ					*/
		hed.nextPage += flashInfo.pageCount;			/* y[WԍvZ					*/
		hed.freePages -= (uint16_t)usePages;			/* 󂫃y[WZ					*/

	} else {
		if ( (uint32_t)flashInfo.pageCount < usePages ) {	/* ݂̃y[WɓȂ		*/
			return ( 5 );
		}
		if ( reserv != 0 ) {
			if ( flashInfo.pageCount < reserv ) {			/* ݂̃y[Wz\?	*/
				return ( 6 );
			}
		}
	}

	/* FatFst@CI[v					*/
	if ( f_open( &fl ,fname ,FA_READ ) != FR_OK ) {
		return ( 7 );
	}

	/* SPItbVy[Wԍݒ			*/
	page = flashInfo.topPage;

	/* ʏt@C]							*/
	if ( ftype == FLASH_FS_FILE ) {
		while ( fl.fptr < fl.fsize ) {

			/* EIb`hbN^C}[Zbg	*/
			#if (WDT_MODE)
			wdt_reset();
			#endif

			/* t@Cǂݍ					*/
			if ( f_read( &fl ,pageBuffer ,512 ,&n ) != FR_OK ) {
				f_close( &fl );
				return ( 8 );
			}

			/* SPItbV֓]				*/
			if ( flashWritePage( page++ ,pageBuffer ) != 0 ) {
				f_close( &fl );
				return ( 8 );
			}
		}

	/* BMPt@C]							*/
	} else {
		bpc = bi.biBitCount / 8;				/* 1sNZ̃oCg	*/
		bpl = (uint16_t)bi.biWidth * bpc;		/* 1C̃oCg		*/
		if ( bpl % 4 ) {
			bpl = ( ( bpl / 4 ) + 1 ) * 4;		/* 4oCgE					*/
		}

		fpos = bf.bfOffBits + ( (uint32_t)bpl * bi.biHeight );
		fpos -= (uint32_t)bpl;
		p = pageBuffer;
		for ( y = 0 ;y < (uint16_t)bi.biHeight ;y++ ) {
	
			/* EIb`hbN^C}[Zbg	*/
			#if (WDT_MODE)
			wdt_reset();
			#endif

			/* vOXo[\				*/
			if ( func != NULL ) {
				(*func)( y ,(uint16_t)bi.biHeight );
			}

			/* s̐擪ʒuɃt@C|C^ړ	*/
			if ( f_lseek( &fl ,fpos ) != FR_OK ) {
				f_close( &fl );
				return ( 10 );
			}

			for ( x = 0 ; x < (uint16_t)bi.biWidth ;x++ ) {

				/* 1sNZ擾						*/
				if ( ( f_read( &fl ,buf ,bpc ,&n ) != FR_OK ) || ( n != bpc ) ) {
					f_close( &fl );
					return ( 11 );
				}

				/* tJ[摜̏ꍇA16bitlɕϊ	*/
				if ( bpc == 3 ) {
					*p++ = ( buf[2] & 0xf8 ) | ( buf[1] >> 5);
					*p++ = ( ( buf[1] & 0x1c ) << 3 ) | ( buf[0] >> 3);
				/* 16bit摜̏ꍇAoCgI[_[ϊ	*/
				} else {
					*p++ = buf[1];
					*p++ = buf[0];
				}

				/* SPItbV֓]					*/
				if ( ( p - pageBuffer ) == 512 ) {
					if ( flashWritePage( page++ ,pageBuffer ) != 0 ) {
						f_close( &fl );
						return ( 8 );
					}
					p = pageBuffer;
				}
			}

			fpos -= (uint32_t)bpl;
		}

		/* ݂̃tbVy[W					*/
		if ( p != pageBuffer ) {
			if ( flashWritePage( page++ ,pageBuffer ) != 0 ) {
				f_close( &fl );
				return ( 8 );
			}
		}
	}

	/* FatFst@CN[Y								*/
	f_close( &fl );

	/* ǗubN								*/
	if ( newFlag ) {
		if ( flashFsPutHeader( &hed ) ) {
			return ( 14 );
		}
	}

	/* CfbNX񏑍								*/
	if ( flashFsPutIndex( index ,&flashInfo ) != 0 ) {
		return ( 15 );
	}

	return ( 0 );
}

/*****************************************************************************
*					SDJ[h̃t@CBMPwb_擾
* Fchar             *fname t@C
*		BITMAPFILEHEADER *bf    t@Cwb_ǂݍݗ̈
*		BITMAPINFOHEADER *bi    BMPwb_ǂݍݗ̈
* ߒlFuint8_t                 0:OK 1:t@CANZXG[ 2:BMPł͂Ȃ
*****************************************************************************/
uint8_t flashFsGetBmpHeader( char *fname ,BITMAPFILEHEADER *bf ,BITMAPINFOHEADER *bi )
{
	FIL fl;
	uint16_t n;

	if ( f_open( &fl ,fname ,FA_READ ) != FR_OK ) {
		return ( 1 );
	}

	if ( ( f_read( &fl ,bf ,sizeof(BITMAPFILEHEADER) ,&n ) != FR_OK ) || ( n != sizeof(BITMAPFILEHEADER) ) ) {
		f_close( &fl );
		return ( 1 );
	}

	if ( ( f_read( &fl ,bi ,sizeof(BITMAPINFOHEADER) ,&n ) != FR_OK ) || ( n != sizeof(BITMAPINFOHEADER) ) ) {
		f_close( &fl );
		return ( 1 );
	}

	f_close( &fl );

	/* 'BM' ʕ`FbN		*/
	if ( memcmp_P( &bf->bfType ,PSTR("BM") ,2 ) != 0 ) {
		return ( 2 );
	}

	/* sNZtH[}bg`FbN	*/
	if ( ( bi->biBitCount != 24 ) && ( bi->biBitCount != 16 ) ) {		/* FKiO	*/
		return ( 2 );
	}

	/* f`FbN				*/
	if ( ( bi->biHeight == 0L ) || ( bi->biWidth == 0L ) ) {
		return ( 2 );
	}

	if ( ( bi->biHeight > 128L ) || ( bi->biWidth > 128L ) ) {
		return ( 2 );
	}

	return ( 0 );
}

/*****************************************************************************
*			tbVVS1053Bp̃pb`EvOCDSP֓Kp
* Fuint8_t index vOCfbNX
* ߒlFvoid
*****************************************************************************/
void vsLoadFlashCode( uint8_t index )
{
	FLASH_FS_INFO inf;
	uint16_t addr = 0;
	uint16_t len  = 0;
	uint16_t data = 0;
	uint16_t cnt;

	flashFsGetIndex( index ,&inf );					/* t@C擾		*/
	cnt = ( (uint16_t)inf.fsize - 12 ) / 2;			/* [hvZ			*/

	flashContinuousArrayRead( inf.topPage ,12 );
	while ( cnt ) {
		flashReadBLOCK( &addr ,2 );
		flashReadBLOCK( &len ,2 );
		cnt -= 2;

		if ( len & 0x8000 ) {		/* RLE run, replicate len samples		*/
			len &= 0x7fff;
			flashReadBLOCK( &data ,2 );
			cnt--;
			while ( len-- ) {
				vsRegWrite( (uint8_t)addr ,data );
			}
		} else {					/* Copy run, copy len samples			*/
			while ( len-- ) {
				flashReadBLOCK( &data ,2 );
				cnt--;
				vsRegWrite( (uint8_t)addr ,data );
			}
		}
	}
	FLASH_DISABLE_CS();
}

/*****************************************************************************
*							t@CVXewb_擾
* FFLASH_FS_HEADER *hed
* ߒlFvoid
*****************************************************************************/
static void flashFsGetHeader( FLASH_FS_HEADER *hed )
{
	flashContinuousArrayRead( HEADER_PAGE ,0 );
	flashReadBLOCK( hed ,sizeof( FLASH_FS_HEADER ) );
	FLASH_DISABLE_CS();
}

/*****************************************************************************
*						t@CVXewb_
* FFLASH_FS_HEADER *hed
* ߒlFuint8_t         0:OK !0:NG
*****************************************************************************/
static uint8_t flashFsPutHeader( FLASH_FS_HEADER *hed )
{
	/* tbVobt@OɃf[^	*/
	flashBufferWrite( FLASH_BUFFER1 ,0 );
	flashWriteBLOCK( hed ,sizeof(FLASH_FS_HEADER) );
	for ( uint16_t offset = sizeof(FLASH_FS_HEADER) ;offset < 512 ;offset++ ) {
		flashWriteBYTE( 0x00 );
	}
	FLASH_DISABLE_CS();

	/* tbVy[Wɏ				*/
	flashBufferToPage( FLASH_BUFFER1 ,HEADER_PAGE );
	
	/* RyA								*/
	if ( flashComparePageToBuffer( FLASH_BUFFER1 ,HEADER_PAGE ) != 0 ) {
		return ( 1 );
	}

	return ( 0 );
}

/*****************************************************************************
*						t@CCfbNX
* Fuint16_t      index CfbNXԍ
*       FLASH_FS_INFO *info CfbNX
* ߒlFuint8_t             0:OK !0:NG
*****************************************************************************/
static uint8_t flashFsPutIndex( uint16_t index ,FLASH_FS_INFO *info )
{
	FLASH_FS_HEADER hed;
	uint16_t page;
	uint16_t offset;

	/* t@CVXewb_擾	*/
	flashFsGetHeader( &hed );

	/* CfbNX񏑍		*/
	page = INDEX_PAGE + ( index / INDEXS_PER_PAGE );
	offset = ( index % INDEXS_PER_PAGE ) * sizeof(FLASH_FS_INFO);

	flashPageToBuffer( FLASH_BUFFER1 ,page );
	flashBufferWrite( FLASH_BUFFER1 ,offset );
	flashWriteBLOCK( info ,sizeof(FLASH_FS_INFO) );
	FLASH_DISABLE_CS();

	flashBufferToPage( FLASH_BUFFER1 ,page );

	/* RyA								*/
	if ( flashComparePageToBuffer( FLASH_BUFFER1 ,page ) != 0 ) {
		return ( 1 );
	}

	return ( 0 );
}
