/*###########################################################################
#                                                                           #
#                  @FMXe[VXg֘AW[                     #
#                                                                           #
###########################################################################*/
#define __FM_ITEMS_C__
#include "project.h"

/* ^Cv`					*/
#define C_SJIS 0
#define C_UTF8 1
#define C_UTF16LE 2
#define C_UTF16BE 3

/* [Jϐvg^Cv錾		*/
static uint32_t getStationListTimeStamp( void );
static uint8_t ex_fgets( FIL *fl ,uint8_t codeType , uint16_t bufferSize ,char *str );
static uint16_t ex_fgetc( FIL *fl ,uint8_t codeType );

/*****************************************************************************
*				wgXe[VACe
* Fvoid
* ߒlFuint8_t Xe[VXgACe
*****************************************************************************/
uint8_t getStationItemCount( void )
{
	eeprom_busy_wait();
	uint8_t itemCount = (uint8_t)eeprom_read_word( (uint16_t *)( EEP_STATION_LIST_ADDRESS + 6 ) );
	return ( itemCount );
}

/*****************************************************************************
*					wCfbNX̃Xe[VACe擾
* Fuint8_t itemIndex ACeԍ
*		FM_ITEM *st       Xe[V
* ߒlFuint8_t           擾ACeCfbNX(0xff:G[)
*                         ߂l 0xff ̏ꍇAst0x00ŃNA
*****************************************************************************/
uint8_t getStationItem( uint8_t itemIndex ,FM_ITEM *st )
{
	uint8_t itemCount = getStationItemCount();
	if ( itemIndex < itemCount ) {
		eeprom_busy_wait();
		eeprom_read_block( st ,(void *)FM_STATION_ITEM_ADR( itemIndex ) ,sizeof(FM_ITEM) );
		return ( itemIndex );
	}

	memset( st ,0x00 ,sizeof(FM_ITEM) );
	return ( 0xff );
}

/*****************************************************************************
*				wgXe[VACe
* Fuint16_t freq g
*		FM_ITEM  *st  ꂽf[^ۑ̈ւ̃|C^
* ߒlFuint8_t       ACeCfbNX(0xff:݂Ȃ)
*                     ߂l 0xff ̏ꍇAst0x00ŃNA
*****************************************************************************/
uint8_t findStationItem( uint16_t freq ,FM_ITEM *st )
{
	uint8_t itemCount = getStationItemCount();
	for ( uint8_t i = 0 ;i < itemCount ;i++ ) {
		getStationItem( i ,st );
		if ( freq == st->freq ) {
			return ( i );
		}
	}

	memset( st ,0x00 ,sizeof(FM_ITEM) );
	return ( 0xff );
}

/*****************************************************************************
*						Xe[VXgNA
* Fvoid
* ߒlFvoid
*****************************************************************************/
void clearStationList( void )
{
	/* ^CX^vNA			*/
	eeprom_busy_wait();
	eeprom_write_dword( (uint32_t *)( EEP_STATION_LIST_ADDRESS + 2 ) ,0L );
	
	/* ACeNA				*/
	eeprom_busy_wait();
	eeprom_write_word( (uint16_t *)( EEP_STATION_LIST_ADDRESS + 6 ) ,0 );

	/* CRCl					*/
	uint16_t crc = crc16_CalcEEPROM( EEP_STATION_LIST_ADDRESS + 2 ,FM_STATION_LIST_SIZE );
	eeprom_busy_wait();
	eeprom_write_word( (uint16_t *)EEP_STATION_LIST_ADDRESS ,crc );
}

/*****************************************************************************
*			EEP̃Xe[VXgCRCƋL^ĂCRCr
* Fvoid
* ߒlFuint8_t  0:v
*			    !0:sv
*****************************************************************************/
uint8_t compStationListCRC( void )
{
	/* ۑĂCRC16擾	*/
	eeprom_busy_wait();
	uint16_t CRC1 = eeprom_read_word( (uint16_t *)EEP_STATION_LIST_ADDRESS );

	/* EEP̃f[^CRC16vZ	*/
	uint16_t CRC2 = crc16_CalcEEPROM( EEP_STATION_LIST_ADDRESS + 2 ,FM_STATION_LIST_SIZE );

	return ( ( CRC1 == CRC2 )?0:1 );
}

/*****************************************************************************
*			t@C "FM_LIST.TXT"̓ƋL^Ăr
* Fvoid
* ߒlFuint8_t  0:viXVsvj
*			     1:L^Ă̕ViXVsvj
*				 2:L^ĂÂiXVKvj
*****************************************************************************/
uint8_t compStationListTimeStamp( void )
{
	/* ۑĂ^CX^v擾				*/
	eeprom_busy_wait();
	uint32_t tim1 = eeprom_read_dword( (uint32_t *)( EEP_STATION_LIST_ADDRESS + 2 ) );

	/* t@C "FM_LIST.TXT" ̃^CX^v擾	*/
	uint32_t tim2 = getStationListTimeStamp();

	/* ^CX^vr								*/
	if ( tim1 == tim2 ) {			/* v								*/
		return ( 0 );
	} else if ( tim1 > tim2 ) {		/* L^Ă̕V	*/
		return ( 1 );
	}

	return ( 2 );					/* L^ĂÂ			*/
}

/*****************************************************************************
*			SDނٰިڸ؂ɂuFM_LIST.TXTv̓eEEP֏
*
* Fuint8_t mode   0:t@C̃`FbN̂
*					   1:EEP֏
*		uint16_t *line ǂݍ񂾍s
*
* ߒlFuint8_t      0:OK
*					 1:R[hG[
*			         2:šI[o[
*					 3:Xe[V
*					 4:g\LɌ
*					 5:gKiO
*					 6:Xe[V̂
*					 7:Xe[V̂
*					 8:ACeO
*                 0xff:ANZXG[
*****************************************************************************/
uint8_t loadStationList( uint8_t mode ,uint16_t *line )
{
	char fname[16];
	char txt[258];
	uint8_t buf[4];
	char *p;
	uint8_t i;
	uint8_t j;
	uint8_t ret;
	uint8_t listCount = 0;
	uint16_t n ,n1 ,n2;
	uint16_t len;
	uint32_t fpos;
	uint8_t codeType;
	FIL fl;
	FM_ITEM item;

	/* t@CI[v					*/
	strcpy_P( fname ,PSTR(FM_FILE_NAME) );
	if ( f_open( &fl ,fname ,FA_READ ) != FR_OK ) {
		return ( 0xff );
	}

	/* BOM`FbN						*/
	len = 0;
	if ( fl.fsize >= 3L ) {
		len = 3;
	} else if ( fl.fsize >= 2L ) {
		len = 2;
	} else if ( fl.fsize == 0L ) {
		f_close( &fl );
		return ( 0xff );
	}

	memset( buf ,0x00 ,3 );
	if ( ( f_read( &fl ,buf ,len ,&n ) != FR_OK ) && ( n != len ) ) {
		f_close( &fl );
		return ( 0xff );
	}

	if ( ( buf[0] == 0xef ) && ( buf[1] == 0xbb ) && ( buf[2] == 0xbf ) ) {	/* UTF-8 ?					*/
		fpos = 3L;
		codeType = C_UTF8;
	} else if ( ( buf[0] == 0xfe ) && ( buf[1] == 0xff ) ) {				/* UTF-16BE ?				*/
		fpos = 2L;
		codeType = C_UTF16BE;
	} else if ( ( buf[0] == 0xff ) && ( buf[1] == 0xfe ) ) {				/* UTF-16LE ?				*/
		fpos = 2L;
		codeType = C_UTF16LE;
	} else {																/* S-JIS or UTF-8			*/
		fpos = 0L;
		codeType = C_SJIS;
	}

	if ( f_lseek( &fl ,fpos ) != FR_OK ) {
		f_close( &fl );
		return ( 0xff );
	}

	(*line) = 0;
	while ( 1 ) {
		wdt_reset();
		(*line)++;

		/* 1sǂݍ					*/
		ret = ex_fgets( &fl ,codeType ,sizeof(txt) ,txt );
		if ( ret == 1 ) {				/* EOF ?					*/
			break;
		} else if ( ret == 2 ) {		/* obt@I[o[t[ ?	*/
			f_close( &fl );
			return ( 2 );
		} else if ( ret == 3 ) {		/* t@CANZXG[ or R[hG[ ?	*/
			f_close( &fl );
			return ( 0xff );
		}

		/* 擪̃Xy[X 0x20 XLbv / ̃Xy[X폜	*/
		strtrim( txt );
		p = txt;
		while ( *p == 0x20 ) {
			p++;
		}

		/* RgsXLbv			*/
		if ( ( *p == ';' ) || ( *p == '\0' ) ) {
			continue;
		}

		/* ACe`FbN			*/
		if ( listCount >= FM_LIST_MAX ) {
			f_close( &fl );
			return ( 3 );
		}

		/* g𐔒lɕϊ		*/
		i = 3;
		j = 0;
		n1 = 0;
		n2 = 0;
		while ( ( *p != '\0' ) && ( *p != ',' ) ) {
			if ( *p == '.' ) {			/* _?					*/
				if ( j != 0 ) {			/* _2ȏ゠		*/
					f_close( &fl );
					return ( 4 );
				}
				i = 1;					/* ̌1Ƃ	*/
				j = 1;

			} else {
				if ( ( *p < '0' ) || ( *p > '9' ) ) { /* ȊO ?	*/
					return ( 4 );
				}

				if ( i-- == 0 ) {		/* I[o[?			*/
					f_close( &fl );
					return ( 4 );
				}

				if ( j == 0 ) {				/* l			*/
					n1 *= 10;
					n1 += (uint16_t)(*p) - '0';
				} else {					/* l			*/
					n2 *= 10;
					n2 += (uint16_t)(*p) - '0';
				}
			}

			p++;
		}

		item.freq = ( n1 * 10 ) + n2;			/* Ə				*/
		if ( ( item.freq < FM_MIN_FREQ ) || ( item.freq > FM_MAX_FREQ ) ) {	/* KiȊO		*/
			f_close( &fl );
			return ( 5 );
		}

		/* Xe[Ṽ`FbN		*/
		if ( *p++ != ',' ) {					/* Xe[V̕0		*/
			f_close( &fl );
			return ( 6 );
		}

		n1 = strlen( p );
		if ( n1 > FM_STATION_NAME_LENGTH ) {	/* Xe[V̕񒷃I[o[	*/
			f_close( &fl );
			return ( 7 );
		}

		/* EEP֏				*/
		if ( mode != 0 ) {
			void *adr = (void *)FM_STATION_ITEM_ADR( listCount );
			strcpy( item.name ,p );
			eeprom_busy_wait();
			eeprom_write_block( &item ,adr ,sizeof(FM_ITEM) );
		}

		listCount++;
	}

	f_close( &fl );

	if ( mode != 0 ) {
		if ( listCount == 0 ) {
			clearStationList();

		} else {
			/* ^CX^v				*/
			uint32_t tim = getStationListTimeStamp();
			eeprom_busy_wait();
			eeprom_write_dword( (uint32_t *)( EEP_STATION_LIST_ADDRESS + 2 ) ,tim );

			/* ACe				*/
			eeprom_busy_wait();
			eeprom_write_word( (uint16_t *)( EEP_STATION_LIST_ADDRESS + 6 ) ,listCount );

			/* CRC						*/
			uint16_t crc = crc16_CalcEEPROM( EEP_STATION_LIST_ADDRESS + 2 ,FM_STATION_LIST_SIZE );
			eeprom_busy_wait();
			eeprom_write_word( (uint16_t *)EEP_STATION_LIST_ADDRESS ,crc );
		}
	}

	if ( listCount == 0 ) {						/* Xe[V0				*/
		return ( 8 );
	}

	return ( 0 );
}

/*****************************************************************************
*					t@C "FM_LIST.TXT"̃^CX^v擾
* Fvoid
* ߒlFuint32_t ^CX^v ( t@C݂Ȃꍇ0Ԃ )
*****************************************************************************/
static uint32_t getStationListTimeStamp( void )
{
	char fname[16];
	FILINFO inf;

	strcpy_P( fname ,PSTR(FM_FILE_NAME) );
	if ( f_stat( fname ,&inf ) != FR_OK ) {
		return ( 0L );
	}

	uint32_t fileTimeStamp = ( (uint32_t)inf.fdate << 16 ) | (uint32_t)inf.ftime;
	return ( fileTimeStamp );
}

/*****************************************************************************
*					t@CeLXgPsǂݍ
* FFIL      *fl         FatFst@C\
*		uint8_t  codeType    R[h^Cv
*		uint16_t bufferSize  i[obt@TCY(Bytes)
*       char     *str        i[obt@
* ߒlFuint8_t              0:OK
*					         1:EOF
*				             2:obt@I[o[t[
*							 3:t@CANZXG[ or R[hG[
*****************************************************************************/
static uint8_t ex_fgets( FIL *fl ,uint8_t codeType , uint16_t bufferSize ,char *str )
{
	uint8_t *p = (uint8_t *)str;
	uint16_t sjis;

	while ( 1 ) {
		sjis = ex_fgetc( fl ,codeType );
		
		if ( sjis == 0x0000 ) {					/* EOF ?			*/
			break;
		}

		if ( sjis == 0xffff ) {					/* t@CG[?	*/
			return ( 3 );
		}

		if ( sjis == '\r' ) {
			continue;
		}

		if ( sjis == '\n' ) {
			break;
		}

		if ( sjis & 0xff00 ) {
			if ( !bufferSize ) {
				return ( 2 );
			}
			*p++ = (uint8_t)( sjis >> 8 );
			bufferSize--;
		}

		if ( !bufferSize ) {
			return ( 2 );
		}
		*p++ = (uint8_t)sjis;
		bufferSize--;
	}

	if ( !bufferSize ) {
		return ( 2 );
	}
	*p = '\0';

	return ( ( sjis == 0 ) ? 1 : 0 );
}

/*****************************************************************************
*						t@CPǂݍ
*
* FFIL     *fl      FatFst@C\
*		uint8_t codeType R[h^Cv
* ߒlFuint16_t         ǂݍݕR[h(S-JIS)
*						 0x0000 : EOF
*						 0xffff : t@CANZXG[ or R[hG[
*****************************************************************************/
static uint16_t ex_fgetc( FIL *fl ,uint8_t codeType )
{
	uint8_t dat[4];
	uint16_t n;
	uint16_t len;
	uint16_t code;
	uint16_t sjis;

	if ( fl->fptr >= fl->fsize ) {					/* EOF ?				*/
		return ( 0 );
	}
	
	/* UTF-8 R[h擾					*/
	if ( codeType == C_UTF8 ) {
		if ( ( f_read( fl ,dat ,1 ,&n ) != FR_OK ) || ( n != 1 ) ) {
			return ( 0xffff );
		}

		if ( ( dat[0] & 0x80 ) == 0x00 ) {			/* U+0x0000...U+0x007F ?	*/
			dat[0] &= 0x7f;
			len = 0;

		} else if ( ( dat[0] & 0xe0 ) == 0xc0 ) {	/* U+0x0080...U+0x07FF ?	*/
			dat[0] &= 0x1f;
			len = 1;

		} else if ( ( dat[0] & 0xf0 ) == 0xe0 ) {	/* U+0x0800...U+0xFFFF ?	*/
			dat[0] &= 0x0f;
			len = 2;

		} else {									/* T|[gO?				*/
			return ( 0xffff );
		}

		code = (uint16_t)dat[0];
		if ( len ) {
			if ( ( f_read( fl ,dat ,len ,&n ) != FR_OK ) || ( n != len ) ) {
				return ( 0xffff );
			}

			for ( n = 0 ;n < len ;n++ ) {
				if ( ( dat[n] & 0xc0 ) != 0x80 ) {	/* rbgzuG[?		*/
					return ( 0xffff );
				}
				code <<= 6;
				code |= (uint16_t)( dat[n] & 0x3f );
			}
			sjis = unicodeToSJIS( code );
		}

	/* UTF-16LE R[h擾				*/
	} else if ( codeType == C_UTF16LE ) {
		if ( ( f_read( fl ,dat ,2 ,&n ) != FR_OK ) || ( n != 2 ) ) {
			return ( 0xffff );
		}
		code = (uint16_t)dat[0] | ( (uint16_t)dat[1] << 8 );
		sjis = unicodeToSJIS( code );

	/* UTF-16BE R[h擾				*/
	} else if ( codeType == C_UTF16BE ) {
		if ( ( f_read( fl ,dat ,2 ,&n ) != FR_OK ) || ( n != 2 ) ) {
			return ( 0xffff );
		}
		code = ( (uint16_t)dat[0] << 8 ) | (uint16_t)dat[1];
		sjis = unicodeToSJIS( code );

	/* S-JIS or UTF-8 R[h擾		*/
	} else {
		sjis = 0;

		if ( ( f_read( fl ,&dat[0] ,1 ,&n ) != FR_OK ) || ( n != 1 ) ) {
			return ( 0xffff );
		}

		/* UTF-8 ̉\mF			*/
		if ( ( dat[0] & 0xe0 ) == 0xc0 ) {			/* U+0x0080...U+0x07FF ?	*/
			dat[0] &= 0x1f;
			len = 1;
		} else if ( ( dat[0] & 0xf0 ) == 0xe0 ) {	/* U+0x0800...U+0xFFFF ?	*/
			dat[0] &= 0x0f;
			len = 2;
		} else {
			len = 0;
		}

		/* UTF-8̉\ꍇUTF-8ŃR[h擾݂	*/
		if ( len ) {
			code = (uint16_t)dat[0];
			if ( ( f_read( fl ,&dat[1] ,len ,&n ) != FR_OK ) || ( n != len ) ) {
				return ( 0xffff );
			}

			for ( n = 1 ;n <= len ;n++ ) {
				if ( ( dat[n] & 0xc0 ) != 0x80 ) {	/* rbgzuG[?		*/
					if ( f_lseek( fl ,fl->fptr - (uint32_t)len ) != FR_OK ) {
						return ( 0xffff );
					}
					code = 0;
					break;
				}
				code <<= 6;
				code |= (uint16_t)( dat[n] & 0x3f );
			}
			sjis = unicodeToSJIS( code );
		}

		/* UTF-8̉\̂S-JISR[h擾	*/
		if ( sjis == 0 ) {
			sjis = (uint16_t)dat[0];
			if ( IS_SJIS1( dat[0] ) ) {				/* S-JIS 1oCg?			*/
				if ( ( f_read( fl ,&dat[1] ,1 ,&n ) != FR_OK ) || ( n != 1 ) ) {
					return ( 0xffff );
				}

				if ( !IS_SJIS2( dat[1] ) ) {		/* S-JIS 2oCgڈȊO?		*/
					return ( 0xffff );
				}
				sjis <<= 8;
				sjis |= (uint16_t)dat[1];
			}
		}
	}

	return ( sjis );
}
