/*###########################################################################
#                                                                           #
#                   {^iL[j䃂W[                            #
#                                                                           #
###########################################################################*/
#define __KEYS_C__
#include <avr/io.h>
#include <avr/interrupt.h>
#include "keys.h"

/* W[[Jϐ錾 */
static uint8_t keyBuf[ KEY_BUFFER_SIZE ];	/* L[obt@								*/
static uint8_t reptFlag[ KEY_MAX + 1 ];		/* L[s[gLtO 0: 1:L	*/
static uint8_t readPointer 	= 0;			/* L[obt@[h|C^				*/
static uint8_t writePointer = 0;			/* L[obt@Cg|C^				*/
static uint8_t dataCount 	= 0;			/* L[obt@Lf[^				*/
static uint8_t backButton	= 0;			/* O񉟂Ă{^ԍ					*/
static uint8_t reptCounter	= 0;			/* L[s[gpJE^					*/
static uint8_t longPush 	= 0;			/* tO								*/

volatile static uint8_t jogDir = 0;			/* WO_C 0:ω  1:Up 2:Down		*/
volatile static uint8_t jogSts = 0;			/* WO_CXe[^X					*/

/* [J֐vg^Cv錾 */
static void keysAdd( uint8_t key );			/* L[obt@֓o^						*/

/*****************************************************************************
*					sω荞݁iWO_Cj
*****************************************************************************/
ISR( SIG_PIN_CHANGE0 )
{
	if ( jogDir == 0 ) {
		uint8_t pb = ( PINB & 0x30 ) >> 4;
		jogSts = ( ( jogSts << 2 ) + pb ) & 0x0f;	/* GR[_PB4/PB5ɐڑĂ */
		if ( jogSts == 0x07 ) {						/* 1 -> 3 */
			jogDir = 2;
		} else if ( jogSts == 0x0d ) {				/* 3 -> 1 */
			jogDir = 1;
		}
	}
}

/*****************************************************************************
*				݉Ă{^ԍ擾iΉ)
* F
* ߒlFuint8_t {^ԍ( 0:@^@1` j
* L[obt@Ƃ͊֌WȂ݂̃{^󋵂擾BL[obt@ւe
*****************************************************************************/
uint8_t keysNowKeyNumber( void )
{
	uint8_t pf = PINF;

	if ( !( pf & _BV(3) ) ) {					/* {^ */
		return ( KEY_BLACK );
	}

	if ( !( pf & _BV(2) ) ) {					/* {^ */
		return ( KEY_BROWN );
	}

	if ( !( pf & _BV(5) ) ) {					/* ԃ{^ */
		return ( KEY_RED );
	}

	return ( KEY_NOTHING );
}

/*****************************************************************************
*					L[obt@L[ԍo
* Fvoid
* ߒlFuint8_t L[ԍ( 0:f[^	bit 5`0 : L[ԍ
*											6    : Jn
*											7    : 
*****************************************************************************/
uint8_t keysInkey( void )
{
	/* {^obt@o */
	uint8_t i = 0;
	if ( dataCount ) {
		dataCount--;
		i = keyBuf[ readPointer++ ];
		if ( readPointer >= KEY_BUFFER_SIZE ) {
			readPointer = 0;
		}
	}

	return ( i );
}

/*****************************************************************************
*						L[W[
* Fvoid
* ߒlFvoid
*****************************************************************************/
void keysInit( void )
{
	keysClear();
	for ( uint8_t i = 0 ;i <= KEY_MAX ;i++ ) {
		reptFlag[i] = 0;
	}
	jogSts = ( ( jogSts << 2 ) + ( PINB >> 6 ) ) & 0x0f;
}

/*****************************************************************************
*						L[s[gLEݒ
* Fuint8_t key L[ԍ
*		uint8_t flg 0: 1:L
* ߒlFvoid
*****************************************************************************/
void keysRepetEnable( uint8_t key ,uint8_t flg )
{
	if ( flg ) {
		reptFlag[key] = 1;
	} else {
		reptFlag[key] = 0;
	}
	keysClear();
}

/*****************************************************************************
*						L[obt@NA
* Fvoid
* ߒlFvoid
*****************************************************************************/
void keysClear( void )
{
	jogDir = 0;
	dataCount= 0;
	readPointer = 0;
	writePointer = 0;
	reptCounter = 0;
}

/*****************************************************************************
*		{^ԂĎĂ{^ԍ{^obt@Ɏ[
* F
* ߒlF
*			10msecԊuŌĂяoƂŁAmȃL[s[g
*			{^𗣂쎞ɁAL[obt@֏܂
*****************************************************************************/
void keysWatchKey( void )
{
	/* ݉ĂL[ԍ擾 */
	uint8_t key = keysNowKeyNumber();

	/* {^𗣂ȂŎ̃{^ꂽꍇ̏ */
	if ( ( key != KEY_NOTHING ) && ( backButton != KEY_NOTHING ) && ( key != backButton ) ) {
		key = KEY_NOTHING;
	}

	/* {^Ă鎞̏ */
	if ( key == KEY_NOTHING ) {
		if ( backButton != KEY_NOTHING ) {			/* O񉽂̃{^ĂH */
			if ( longPush ) {
				keysAdd( 0x80 | backButton );
			} else {
				keysAdd( 0x00 | backButton );
			}
		}
		longPush 	= 0;
		reptCounter	= 0;

	/* {^Ă鎞̏ */
	} else {
		if ( backButton == key ) {					/* OƓ{^ĂH */

			/* I[gs[g */
			if ( reptFlag[backButton] ) {
				if ( ++reptCounter >= ( KEY_REPET_DELAY + KEY_REPET_INTERVAL ) ) {
					reptCounter = KEY_REPET_DELAY;
					keysAdd( 0x00 | backButton );
				}

			/* o */
			} else {
				if ( longPush != 1 ) {
					if ( ++reptCounter >= KEY_LONGPUSH_TIME ) {
						longPush = 1;
						keysAdd( 0x40 | backButton );
					}
				}
			}
		}
	}

	/* WO_CԎ擾 */
	if ( jogDir == 1 ) {
		keysAdd( KEY_JOGUP );
		jogDir = 0;
	} else if ( jogDir == 2 ) {
		keysAdd( KEY_JOGDOWN );
		jogDir = 0;
	}

	/* L[ԍޔ */
	backButton = key;
}

/*****************************************************************************
*					L[obt@փL[ԍǉ
* Fuint8_t key L[ԍ(1`)
* ߒlFvoid
*****************************************************************************/
static void keysAdd( uint8_t key )
{
	if ( dataCount < KEY_BUFFER_SIZE ) {
		dataCount++;
		keyBuf[ writePointer++ ] = key;
		if ( writePointer >= KEY_BUFFER_SIZE ) {
			writePointer = 0;
		}
	}
}

