/*###########################################################################
#                                                                           #
#                  @@@@@ VXe֘AW[                        #
#                                                                           #
###########################################################################*/
#define __SYSTEM_C__
#include "project.h"

/* [J֐vg^Cv錾		*/
static void loadSystemFileFromSD( void );
static uint8_t compSystemCRC( void );
static void loadSystemEEP( void );
static void saveSystemEEP( void );

/*****************************************************************************
*							VXe
* Fvoid
* ߒlFvoid
*****************************************************************************/
void systemProcess( void )
{
	uint8_t shutdownType = SHUTDOWN_NONE;	/* Vbg_EtO		*/
	uint16_t volt;

	/* ŒPx -> ݒPx					*/
	if ( ( sys.screenBrightness != eep.screenBrightness ) && ( sys.screenOffCountDownTimer != 0 ) ) {
		sys.screenBrightness = eep.screenBrightness;
		lcdSetBrightness( eep.screenBrightness );

	/* ON -> tF[hAEg(ŒPx)	*/
	} else if ( ( sys.screenOffCountDownTimer == 0 ) && ( sys.screenBrightness > 25 ) && ( sys.tickScreenFade != 0 ) ) {
		sys.tickScreenFade = 0;
		lcdSetBrightness( --sys.screenBrightness );
	}

	/* dOFF^C}[`FbN			*/
	if ( sys.shutdownCountDownTimer == 0 ) {
		shutdownType = SHUTDOWN_TIMER;
	}

	/* drd\ ^@`FbN		*/
	if ( sys.flag_adTranslationCompletion ) {			/* A/DϊH	*/
		sys.flag_adTranslationCompletion = 0;
		volt = sysDraw_battery();
		if ( ( volt != 0 ) && ( volt < SHUTDOWN_LOW_BATT ) ) {	/* low batt	*/
			shutdownType = SHUTDOWN_LOWBATT;
		}
	}

	/*@VXeVbg_Es		*/
	if ( shutdownType != SHUTDOWN_NONE  ) {
		shutdown( shutdownType );
	}
}

/*****************************************************************************
*									dON
* Fvoid
* ߒlFvoid
*****************************************************************************/
void powerON( void )
{
	uint8_t eepLoadMode = 0;

	/* VXeϐNA				*/
	memset( (void *)&sys ,0x00 ,sizeof(SYSTEM) );
	memset( (void *)&eep ,0x00 ,sizeof(EEP) );

	/* dz[h						*/
	POWER_HOLD();

	/* X^[gbZ[W				*/
	player_sound( SOUND_POWER_ON );
	lcdSetBrightness( 255 );
	printf_P( PSTR("nPMP system start\n") );

	/* FatFs hCu}Eg			*/
	f_mount( 0 ,(FATFS *)&sys.fs );

	/* {^ĂEEPp[^ftHgKp	*/
	/* EEPp[^CRCsv̓ftHgKp					*/
	if ( ( keysNowKeyNumber() == KEY_BLACK ) || ( compSystemCRC() != 0 ) ) {
		puts_P( PSTR("eep clear") );
		clearAllEEP();
		eepLoadMode = 1;
	}

	if ( eepLoadMode != 0 ) {
		loadSystemDefault();
	} else {
		loadSystemEEP();
	}

	/* SDJ[h̃VXet@C擾	*/
	loadSystemFileFromSD();

	/* 12X12tHgZbgݒ					*/
	if ( g_createFontSet( FL_GOTHN12X ,FL_GOTZN12X ,&sys.fnt1 ) != 0 ) {
		printf_P( PSTR("fontset1 error") );	
		wdt_reset(); WAIT_MS( 1 );
	}

	/* 16X16tHgZbgݒ					*/
	if ( g_createFontSet( FL_MGOHN16X ,FL_MGOZN16X ,&sys.fnt2 ) != 0 ) {
		printf_P( PSTR("fontset2 error") );	
		wdt_reset(); WAIT_MS( 1 );
	}
}

/*****************************************************************************
*								Vbg_E
* FSHUTDOWN_TYPE type Vbg_E̎
*				SHUTDOWN_USER	 [U[ɂVbg_E
*				SHUTDOWN_TIMER	 ^C}[ɂVbg_E
*				SHUTDOWN_LOWBATT drdቺɂVbg_E
*				SHUTDOWN_NOT_PROCESS_TIMER DSP]Ԓ߂ɂVbg_E
* ߒlF߂Ȃ
*****************************************************************************/
void shutdown( SHUTDOWN_TYPE type )
{
	uint16_t wait = 0;

	/*														*/
	/* dቺEdOFF^C}[ɂVbg_E	*/
	/* ʂtF[hAEg								*/
	/*														*/
	if ( ( type == SHUTDOWN_LOWBATT ) || ( type == SHUTDOWN_TIMER ) ) {
		player_volumeFade( VOLUME_FADE_OUT );
		do {
			wdt_reset();
		} while ( player_volumeFade( VOLUME_FADE_NEXT ) != VOLUME_FADE_NONE );
	}

	/* Đ̏ꍇ̓W[p[^쐬	*/
	if ( sys.playMode & PLAY_STS_OPEN_BIT ) {
		player_pause();
	}

	/* Đ~									*/
	fmReset();
	vsResetPlayMode();
	player_stop();

	/* O[oC^vg֎~				*/
	cli();

	/* I									*/
	switch ( type ) {
		case SHUTDOWN_USER:
			player_sound( SOUND_POWER_OFF );
			break;

		case SHUTDOWN_LOWBATT:
			player_sound( SOUND_LOWBATT );
			break;

		case SHUTDOWN_NOT_PROCESS_TIMER:
			player_sound( SOUND_ERROR );
			break;

		default:
			break;
	}

	/* bZ[W\							*/
	lcdSetBrightness( 0 );
	sysDraw_cls();
	switch ( type ) {
		case SHUTDOWN_TIMER:
			strcpy_P( sys.textBuffer ,PSTR("dnee") );
			g_puts( &sys.fnt2 ,8 ,52 ,sys.textBuffer ,G_HALF ,RGB(255,255,255) ,RGB(0,0,0) );

			strcpy_P( sys.textBuffer ,PSTR("^C}[쓮") );
			g_puts( &sys.fnt2 ,8 ,70 ,sys.textBuffer ,G_HALF ,RGB(0,255,255) ,RGB(0,0,0) );

			wait = 3000;
			break;

		case SHUTDOWN_LOWBATT:
			strcpy_P( sys.textBuffer ,PSTR("dnee") );
			g_puts( &sys.fnt2 ,24 ,25 ,sys.textBuffer ,G_HALF ,RGB(255 ,255,255) ,RGB(0,0,0) );

			strcpy_P( sys.textBuffer ,PSTR("drՂ") );
			g_puts( &sys.fnt2 ,8 ,43 ,sys.textBuffer ,G_HALF ,RGB(255,0,0) ,RGB(0,0,0) );

			strcpy_P( sys.textBuffer ,PSTR("܂B") );
			g_puts( &sys.fnt2 ,8 ,61 ,sys.textBuffer ,G_HALF ,RGB(255,0,0) ,RGB(0,0,0) );

			strcpy_P( sys.textBuffer ,PSTR("[dsĉ") );
			g_puts( &sys.fnt2 ,8 ,79 ,sys.textBuffer ,G_HALF ,RGB(0,255,255) ,RGB(0,0,0) );

			strcpy_P( sys.textBuffer ,PSTR("B") );
			g_puts( &sys.fnt2 ,8 ,97 ,sys.textBuffer ,G_HALF ,RGB(0,255,255) ,RGB(0,0,0) );

			wait = 5000;
			break;

		case SHUTDOWN_NOT_PROCESS_TIMER:
			strcpy_P( sys.textBuffer ,PSTR("dnee") );
			g_puts( &sys.fnt2 ,8 ,34 ,sys.textBuffer ,G_HALF ,RGB(255,255,255) ,RGB(0,0,0) );

			strcpy_P( sys.textBuffer ,PSTR("AChԂ") );
			g_puts( &sys.fnt2 ,8 ,52 ,sys.textBuffer ,G_HALF ,RGB(255,255,0) ,RGB(0,0,0) );

			strcpy_P( sys.textBuffer ,PSTR("K莞Ԃo") );
			g_puts( &sys.fnt2 ,8 ,70 ,sys.textBuffer ,G_HALF ,RGB(255,255,0) ,RGB(0,0,0) );

			strcpy_P( sys.textBuffer ,PSTR("܂B") );
			g_puts( &sys.fnt2 ,8 ,88 ,sys.textBuffer ,G_HALF ,RGB(255,255,0) ,RGB(0,0,0) );

			wait = 3000;
			break;

		default:
			strcpy_P( sys.textBuffer ,PSTR("dnee") );
			g_puts( &sys.fnt2 ,24 ,62 ,sys.textBuffer ,G_HALF ,RGB(255,255,255) ,RGB(0,0,0) );

			wait = 1000;
			break;
	}
	lcdSetBrightness( 255 );

	/* Vbg_E쐬					*/
	for ( uint8_t i = HIS_SHUTDOWN_COUNT - 1 ;i >= 1 ;i-- ) {
		eep.his_powerOnTime[ i ] = eep.his_powerOnTime[ i - 1 ];
		eep.his_shutDownType[ i ] = eep.his_shutDownType[ i - 1 ];
	}
	eep.his_powerOnTime[0] = sys.systemTime;
	eep.his_shutDownType[0] = type;

	/* p[^ۑ					*/
	saveSystemEEP();

	/* 莞ԑ҂						*/
	do {
		wdt_reset();
		SOFT_WAIT_MS( 1 );
	} while ( wait-- );

	/* DSP Zbg						*/
	VS_ENABLE_XRESET();
	
	/* tbVZbg			*/
	FLASH_ENABLE_RESET();

	/* LCDZbg						*/
	lcdSetBrightness( 0 );
	LCD_ENABLE_RESET();

	/* SẴ{^OFFɂȂ܂ő҂	*/
	while ( keysNowKeyNumber() != KEY_NOTHING ) {
		wdt_reset();
	}

	/* dOFF							*/
	POWER_OFF();

	while ( 1 ) {
		wdt_reset();
	}
}

/*****************************************************************************
*							_lł̓drdl擾
* Fvoid
* ߒlFuint16_t drdl( 100{ ) ( 2.4V = 240 )
*****************************************************************************/
uint16_t _getBattVoltage( void )
{
	uint32_t volt = (uint32_t)sys.batteryAD;
	volt *= (uint32_t)( VOLTAGE_R7 + VOLTAGE_R8 );
	volt /= (uint32_t)VOLTAGE_R8;
	volt *= (uint32_t)REF_VOLTAGE;
	volt /= 1024L;
	return ( (uint16_t)volt );
}

/*****************************************************************************
*								drdl擾
* Fvoid
* ߒlFuint16_t drdl( 100{ ) ( 2.4V = 240 )
*****************************************************************************/
uint16_t getBattVoltage( void )
{
	uint32_t volt = (uint32_t)_getBattVoltage();
	if ( eep.voltageCalibration ) {
		volt *= eep.voltageCalibration;
		volt /= 10000L;
	}

	return ( (uint16_t)volt );
}

/*****************************************************************************
*					w̃t@CtbVɃ[h
* Fuint8_t  mode   0:^CX^vrĕKvȏꍇ̂݃[h
*                       1:[h
*		uint16_t index  [hCfbNXԍ
*		char     *fname t@C
*		uint8_t  ftype  t@C^Cv FLASH_FS_FILE  : t@C̓ê܂ܓ]
*						               FLASH_FS_IMAGE : R5G6B5`̃C[Wɕϊē]
*		uint16_t n      mۂy[W(0:)
* ߒlFvoid
*****************************************************************************/
void loadSystemFile( uint8_t mode ,uint16_t index ,char *fname ,uint8_t ftype ,uint16_t n )
{
	FLASH_FS_INFO fl;
	FILINFO ff;

	wdt_reset();
	char *f = getFileName( fname );

	/* FatFst@C擾		*/
	if ( f_stat( fname ,&ff ) != FR_OK ) {
		return;
	}

	/* t@C`FbN				*/
	flashFsGetIndex( index ,&fl );
	if ( strcasecmp( f ,fl.fname ) != 0 ) {		/* t@Csv			*/
		mode = 1;
	}

	/* ^CX^vr	*/
	if ( mode == 0 ) {
		if ( ( ff.fdate < fl.fdate ) || ( ( ff.fdate == fl.fdate ) && ( ff.ftime <=  fl.ftime ) ) ) {
			return;
		}
	}

	/* t@C[h		*/
	printf_P( PSTR("%s ...") ,f );
	uint8_t ret = flashFsCopyFile( index ,ftype ,fname ,n ,NULL );
	if ( ret ) {
		printf_P( PSTR("error %d") ,ret );
		wdt_reset();
		flashFsFormat();
		while ( 1 );
	}
	printf_P( PSTR("OK\n") );
}

/*****************************************************************************
*				VXeϐ eep փftHgp[^Kp
* Fvoid
* ߒlFvoid
*****************************************************************************/
void loadSystemDefault( void )
{
	memset( (void *)&eep ,0x00 ,sizeof(EEP) );	/* S̈0ŃNA								*/
	eep.screenIndex = 1;				/* dONɕ\郁j[ʔԍ					*/
	eep.repetMode = REPET_NONE;			/* s[gĐ[h									*/
	eep.playTimeDisable = 0;			/* sys.playTimetO 0:L !0:				*/
	eep.screenBrightness = 164;			/* ʋPx												*/
	eep.screenOffTimer = 0xffff;		/* OFF^C}[(100msec) 0xffff:					*/
	eep.shutdownTimer = 0xffff;			/* Vbg_E^C}[(1sec) 0xffff: 			*/
	eep.volume = 5;						/* (0`VOLUME_MAXVALUE)								*/
	eep.earSpeaker = 0;					/* EarSpeakerx(0`3)								*/
	eep.hi_freq = 1;					/* g(1`15)KHzȏ				*/
	eep.hi_lv = 0;						/* x1.5db݂Ŏw(-8`7)					*/
	eep.low_freq = 2;					/* g(2`15) Hzȉ̎g(20Hz`150Hz)	*/
	eep.low_lv = 0;						/* x1db݂Ŏw(0`15)					*/
	eep.fmFreq = 761;					/* Mg											*/
	eep.voltageCalibration = 0;			/* drdA/Dϊ␳萔								*/
	eep.systemUpdate = 1;				/* ÑVXet@CmF[h					*/
	eep.bgMode = 0x08;					/* wi[h											*/
	eep.updateAlbumIndex = 0;			/* XVAowiobt@CfbNXԍ	*/
	saveSystemEEP();
}

/*****************************************************************************
*						VXëNA
* Fvoid
* ߒlFvoid
*****************************************************************************/
void clearAllEEP( void )
{
	const uint8_t x1 = 7;
	const uint8_t y1 = 51;
	const uint8_t x2 = 120;
	const uint8_t y2 = y1 + 7;

	uint8_t buf[32];
	memset( buf ,0x00 ,sizeof(buf) );
	for ( uint16_t i = 0 ;i < 4096 ;i += sizeof(buf) ) {
		wdt_reset();
		sysDraw_ProgressBar2( i ,4096 );
		eeprom_busy_wait();
		eeprom_write_block( buf ,(void *)i ,sizeof(buf) );
	}

	lcdFillBox( x1 - 2 ,y1 - 12 ,x2 + 2 ,y2 + 8 ,RGB(0,0,0) );
}

/*****************************************************************************
*			SDJ[hVXet@CtbVփ[h
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void loadSystemFileFromSD( void )
{
	/* FMXe[VXgǂݍݎ̃G[bZ[W	*/
	static const prog_char msg0[] = "file access error";
	static const prog_char msg1[] = "code error";			/* R[hG[			*/
	static const prog_char msg2[] = "characters over";		/* šI[o[			*/
	static const prog_char msg3[] = "items over";			/* Xe[VI[o[	*/
	static const prog_char msg4[] = "freq mistake";			/* g\LԈႢ			*/
	static const prog_char msg5[] = "freq out range";		/* glKiO			*/
	static const prog_char msg6[] = "name void";			/* Xe[V		*/
	static const prog_char msg7[] = "name longer";			/* Xe[V		*/
	static const prog_char msg8[] = "item is nothing";		/* Xe[V0			*/
	static const prog_char msg9[] = "system file error";
	static const prog_char *msg[] PROGMEM = { NULL ,msg1 ,msg2 ,msg3 ,msg4 ,msg5 ,msg6 ,msg7 ,msg8 ,msg9 };

	DIR dir;
	FILINFO ffInfo;
	FLASH_FS_INFO fl;

	uint16_t index;
	uint8_t fmt = 0;
	uint8_t mode;

	/* Xe[VXgCRC`FbN		*/
	if ( compStationListCRC() != 0 ) {
		clearStationList();
	}

	/* tbVID`FbN			*/
	if ( flashFsCheckID() != 0 ) {
		printf_P( PSTR("flash clear ... " ) );
		if ( flashFsFormat() != 0 ) {
			printf_P( PSTR("NG") );
			wdt_reset(); while ( 1 );
		}
		printf_P( PSTR("OK\n") );
		wdt_reset(); WAIT_MS( 1000 ); wdt_reset();
		fmt = 1;
	}

	/* tbVt@CXV				*/
	if ( ( SD_INS() == 0 ) && ( ( fmt != 0 ) || ( eep.systemUpdate != 0 ) ) ) {	/* SDJ[h}?	*/

		/* UNICODEe[u[h			*/
		strcpy_P( sys.textBuffer ,PSTR("SYSTEM/UNICODE") );
		if ( f_opendir( &dir ,sys.textBuffer ) == FR_OK ) {

			/* UNICODE->SJIS ϊe[u[h	*/
			strcpy_P( sys.textBuffer ,PSTR("SYSTEM/UNICODE/UNI2SJIS.BIN") );
			loadSystemFile( 0 ,FL_UNI2SJIS ,sys.textBuffer ,FLASH_FS_FILE ,256 );

			/* SJIS->UNICODE ϊe[u[h	*/
			strcpy_P( sys.textBuffer ,PSTR("SYSTEM/UNICODE/SJIS2UNI.BIN") );
			loadSystemFile( 0 ,FL_SJIS2UNI ,sys.textBuffer ,FLASH_FS_FILE ,256 );
		}

		/* tHgt@C[h				*/
		strcpy_P( sys.textBuffer ,PSTR("SYSTEM/FONTS") );
		if ( f_opendir( &dir ,sys.textBuffer ) == FR_OK ) {

			/* GOTHN12X.TLF 12x12ptHg[h	*/
			strcpy_P( sys.textBuffer ,PSTR("SYSTEM/FONTS/GOTHN12X.TLF") );
			loadSystemFile( 0 ,FL_GOTHN12X ,sys.textBuffer ,FLASH_FS_FILE ,32 );

			/* GOTZN12X.TLF 12x12SptHg[h	*/
			strcpy_P( sys.textBuffer ,PSTR("SYSTEM/FONTS/GOTZN12X.TLF") );
			loadSystemFile( 0 ,FL_GOTZN12X ,sys.textBuffer ,FLASH_FS_FILE ,512 );

			/* MGOHN16X.TLF 16x16ptHg[h	*/
			strcpy_P( sys.textBuffer ,PSTR("SYSTEM/FONTS/MGOHN16X.TLF") );
			loadSystemFile( 0 ,FL_MGOHN16X ,sys.textBuffer ,FLASH_FS_FILE ,32 );

			/* MGOZN16X.TLF 16x16SptHg[h	*/
			strcpy_P( sys.textBuffer ,PSTR("SYSTEM/FONTS/MGOZN16X.TLF") );
			loadSystemFile( 0 ,FL_MGOZN16X ,sys.textBuffer ,FLASH_FS_FILE ,512 );
		}

		/* VS1053Bpb`[h	*/
		strcpy_P( sys.textBuffer ,PSTR("SYSTEM/VSCODE") );
		if ( f_opendir( &dir ,sys.textBuffer ) == FR_OK ) {

			/* spectrumAnalyzer09 : SPECTRUM.VSP		*/
			strcpy_P( sys.textBuffer ,PSTR("SYSTEM/VSCODE/SPECTRUM.VSP") );
			loadSystemFile( 0 ,FL_VS_SPECTRUM ,sys.textBuffer ,FLASH_FS_FILE ,AUTO_RESERV );

			/* vs1053b-vorbis-patch060b : VORBIS.VSP	*/
			strcpy_P( sys.textBuffer ,PSTR("SYSTEM/VSCODE/VORBIS.VSP") );
			loadSystemFile( 0 ,FL_VS_VORBISFIX ,sys.textBuffer ,FLASH_FS_FILE ,AUTO_RESERV );

			/* vs1053b-imafix100 : IMAFIX.VSP			*/
			strcpy_P( sys.textBuffer ,PSTR("SYSTEM/VSCODE/IMAFIX.VSP") );
			loadSystemFile( 0 ,FL_VS_IMAFIX ,sys.textBuffer ,FLASH_FS_FILE ,AUTO_RESERV );
		}

		/* VS1053B OGGGR[_[[h	*/
		/* vs1053-vorbis-encoder-150		*/
		strcpy_P( sys.textBuffer ,PSTR("SYSTEM/VSCODE/OGG") );
		if ( f_opendir( &dir ,sys.textBuffer ) == FR_OK ) {
			index = 0;
			while ( index < 12 ) {
				if ( f_readdir( &dir ,&ffInfo ) != FR_OK ) {
					break;
				}

				if ( ffInfo.fname[0] == '\0' ) {
					break;
				}

				if ( ( ffInfo.fname[0] == '.' ) || ( ffInfo.fattrib & ( AM_DIR | AM_HID | AM_SYS ) ) ) {
					continue;
				}

				if ( strcasecmp_P( getExtension( ffInfo.fname ) ,PSTR("VSP") ) != 0 ) {
					continue;
				}

				strcpy_P( sys.textBuffer ,PSTR("SYSTEM/VSCODE/OGG/") );
				strcat( sys.textBuffer ,ffInfo.fname );
				loadSystemFile( 0 ,FL_VS_OGG + index ,sys.textBuffer ,FLASH_FS_FILE ,AUTO_RESERV );
				index++;
			}
		}

		/* ACRt@C[h				*/
		strcpy_P( sys.textBuffer ,PSTR("SYSTEM/IMAGES") );
		if ( f_opendir( &dir ,sys.textBuffer ) == FR_OK ) {
			for ( uint8_t i = 0 ;i < 160 ;i++ ) {
				sprintf_P( sys.textBuffer ,PSTR("SYSTEM/IMAGES/ICON%03d.BMP") ,i );
				loadSystemFile( 0 ,FL_ICON_START_INDEX + i ,sys.textBuffer ,FLASH_FS_IMAGE ,AUTO_RESERV );
			}
		}
	}

	/* VXewiftHgt@C[h	*/
	if ( SD_INS() == 0 ) {
		strcpy_P( sys.textBuffer ,PSTR("SYSTEM/IMAGES/DEFAULT.BMP") );
		flashFsGetIndex( FL_BG_SYSTEM_INDEX ,&fl );
		if ( ( fl.fname[0] == '\0' ) || ( fl.width != 128 ) || ( fl.height != 128 ) || ( fl.ftype != FLASH_FS_IMAGE ) ) {
			mode = 1;
		} else {
			mode = 0;
		}
		loadSystemFile( mode ,FL_BG_SYSTEM_INDEX ,sys.textBuffer ,FLASH_FS_IMAGE ,64 );
	}

	/* UNICODEe[u			*/
	unicode_init();

	/* Xe[VXgXV				*/
	if ( SD_INS() == 0 ) {
		if ( compStationListTimeStamp() == 2 ) {	/* ^CX^vÂ?	*/
			uint8_t ret;
			uint16_t line = 0;
			puts_P( PSTR("station list update") );
			ret = loadStationList( 0 ,&line );		/* FM_LIST.DAT`FbN	*/
			if ( ret == 0 ) {
				ret = loadStationList( 1 ,&line );	/* FM_LIST.DAT荞	*/
			}

			if ( ret != 0 ) {
				printf_P( PSTR("line %3d\n") ,line );
				if ( ret <= 8 ) {
					puts_P( (prog_char *)pgm_read_word( &msg[ret] ) );
				} else {
					puts_P( msg0 );
				}
				wdt_reset(); while ( 1 );

			} else {
				puts_P( PSTR("station list update success") );
			}
			wdt_reset(); WAIT_MS( 1000 ); wdt_reset();
		}
	}

	/* UNICODEVXe`FbN			*/
	if ( unicode_check() ) {
		puts_P( msg9 );
		wdt_reset(); while ( 1 );
	}
}

/*****************************************************************************
*				VXe\ eep EEPROMփZ[u
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void saveSystemEEP( void )
{
	/* ϐubN			*/
	eeprom_busy_wait();
	eeprom_write_block( (void *)&eep ,(void *)( EEP_SYSTEM_ADDRESS + 2 ) ,sizeof(EEP) );

	/* CRC16				*/
	uint16_t crc16 = crc16_CalcEEPROM( EEP_SYSTEM_ADDRESS + 2 ,sizeof(EEP) );
	eeprom_busy_wait();
	eeprom_write_word( (uint16_t *)EEP_SYSTEM_ADDRESS ,crc16 );
}

/*****************************************************************************
*				EEP̃VXeϐCRCƋL^ĂCRCr
* Fvoid
* ߒlFuint8_t  0:v
*			    !0:sv
*****************************************************************************/
static uint8_t compSystemCRC( void )
{
	/* ۑĂCRC16擾	*/
	eeprom_busy_wait();
	uint16_t CRC1 = eeprom_read_word( (uint16_t *)EEP_SYSTEM_ADDRESS );

	/* EEP̃f[^CRC16vZ	*/
	uint16_t CRC2 = crc16_CalcEEPROM( EEP_SYSTEM_ADDRESS + 2 ,sizeof(EEP) );

	return ( ( CRC1 == CRC2 )?0:1 );
}

/*****************************************************************************
*					VXeϐ eep EEPROMǂݍ
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void loadSystemEEP( void )
{
	/* ϐubNǂݍ			*/
	eeprom_busy_wait();
	eeprom_read_block( (void *)&eep ,(void *)( EEP_SYSTEM_ADDRESS + 2 ) ,sizeof(EEP) );
}
