/*###########################################################################
#                                                                           #
#						UNICODE -> SJIS ϊ֐Q							#
#                                                                           #
###########################################################################*/
#define __UNICODE_C__

#include <stdio.h>
#include "timer.h"

#include <string.h>
#include <avr/io.h>

#include "at45db161d.h"
#include "flash_sys.h"
#include "unicode.h"

/* ee[ũtbVt@CCfbNX`	*/
#define FL_UNI2SJIS 0				/* UNI2SJIS.BIN : UNICODE -> SJISϊ		*/
#define FL_SJIS2UNI 1				/* SJIS2UNI.BIN : SJISE -> UNICODEϊ		*/

/* [Jϐ`					*/
static uint32_t uniTopAddress = 0L;
static uint32_t sjisTopAddress = 0L;

/* [J֐vg^Cv錾		*/
static uint8_t check_sjis( char *s );
static uint8_t unicode_UTF8toSJIS( char *s ,char *d ,uint16_t bufferMax );
static uint8_t unicode_UTF16toSJIS( char *s ,char *d ,uint16_t bufferMax ,uint8_t mode );

/*****************************************************************************
*						jR[hVXe
* Fvoid
* ߒlFvoid
*****************************************************************************/
void unicode_init( void )
{
	FLASH_FS_INFO inf;

	flashFsGetIndex( FL_UNI2SJIS ,&inf );
	uniTopAddress = (uint32_t)inf.topPage * 512L;

	flashFsGetIndex( FL_SJIS2UNI ,&inf );
	sjisTopAddress = (uint32_t)inf.topPage * 512L;
}

/*****************************************************************************
*						jR[hVXeԎ擾
* Fvoid
* ߒlFuint8_t 0:OK !0:NG
*****************************************************************************/
uint8_t unicode_check( void )
{
	FLASH_FS_INFO inf;

	flashFsGetIndex( FL_UNI2SJIS ,&inf );
	if ( inf.topPage == 0 ) {
		return ( 1 );
	}

	flashFsGetIndex( FL_SJIS2UNI ,&inf );
	if ( inf.topPage == 0 ) {
		return ( 1 );
	}

	return ( 0 );
}

/*****************************************************************************
*						eS-JISɕϊ
* Fchar    *s  ϊf[^(ŌɕK'\0'3ȏ㑱Ă邱)
*		uint16_t pr vCIeB
*						PR_UTF16_UTF8_SJIS
*						PR_UTF8_UTF16_SJIS
*						PR_SJIS_UTF8_UTF16
*						PR_UTF8_SJIS_UTF16
*
* ߒlFuint8_t ϊ̕R[h
*						CODE_NONE    : R[hʂł
*						CODE_SJIS    : S-JIS
*						CODE_UTF16LE : UTF-16LE
*						CODE_UTF16BE : UTF-16BE
*						CODE_UTF8    : UTF-8
*****************************************************************************/
uint8_t unicode_ConvSJIS( char *s ,uint16_t pr )
{
	char buf[258];
	uint8_t ret;
	uint8_t i;
	uint8_t typ;

	for ( i = 0 ;i < 4 ;i++ ) {
		typ = ( pr & 0x07 );

		/* UTF-8 -> S-JIS					*/
		if ( typ == CODE_UTF8 ) {
			ret = unicode_UTF8toSJIS( s ,buf ,sizeof(buf) );
			if ( ret == 0 ) {
				strcpy( s ,buf );
				return ( CODE_UTF8 );
			}
		
		/* UTF-16LE -> S-JIS				*/
		} else if ( typ == CODE_UTF16LE ) {
			ret = unicode_UTF16toSJIS( s ,buf ,sizeof(buf) ,0 );
			if ( ret == 0 ) {
				strcpy( s ,buf );
				return ( CODE_UTF16LE );
			}

		/* UTF-16BE -> S-JIS				*/
		} else if ( typ == CODE_UTF16BE ) {
			ret = unicode_UTF16toSJIS( s ,buf ,sizeof(buf) ,1 );
			if ( ret == 0 ) {
				strcpy( s ,buf );
				return ( CODE_UTF16BE );
			}

		/* S-JISȂ̂`FbN		*/
		} else {
			ret = check_sjis( s );
			if ( ret == 0 ) {
				return ( CODE_SJIS );
			}
		}

		pr >>= 3;
	}

	return ( CODE_NONE );
}

/*****************************************************************************
*					UTF-16 -> S-JIS@R[hϊ
* Fuint16_t code UNICODE
* ߒlFuint16_t      S-JISR[h( 0 : ΉR[h)
*****************************************************************************/
uint16_t unicodeToSJIS( uint16_t code )
{
	uint16_t sjis;
	flashRead( uniTopAddress + ( (uint32_t)code * 2L ) ,&sjis ,2 );
	return ( sjis );
}

/*****************************************************************************
*							S-JIS`FbN
* Fchar     *s        ͕
* ߒlFuint8_t            0:S-JIS 1:S-JISȊO
*****************************************************************************/
static uint8_t check_sjis( char *s )
{
	uint8_t c;
	while ( 1 ) {
		c = *s++;

		/* I[R[h`FbN		*/
		if ( c == '\0' ) {
			if ( *s == '\0' ) {
				break;
			} else {
				return ( 1 );
			}
		}

		if ( IS_SJIS1(c) ) {					/* SpJnR[hH			*/
			c = *s++;
			if ( !IS_SJIS2(c) ) {				/* 2oCgڂG[H		*/
				return ( 2 );
			}
		}
	}

	return ( 0 );
}

/*****************************************************************************
*						UTF-8 -> S-JIS ϊ
* Fchar     *s        ͕
*		char     *d        ö͕
*		uint16_t bufferMax ö͕TCY
* ߒlFuint8_t            0: / !0:s
*****************************************************************************/
static uint8_t unicode_UTF8toSJIS( char *s ,char *d ,uint16_t bufferMax )
{
	uint16_t code;
	uint16_t sjis;
	uint8_t b;
	uint8_t n;

	/* ϊC						*/
	while ( 1 ) {
		b = (uint8_t)*s++;

		/* I[R[h`FbN			*/
		if ( b == '\0' ) {
			if ( *s == '\0' ) {
				break;
			} else {
				return ( 1 );
			}
		}

		/* LN^擪oCgmF	*/
		if ( ( b & 0x80 ) == 0x00 ) {				/* U+0x0000...U+0x007F ?		*/
			b &= 0x7f;
			n = 0;

		} else if ( ( b & 0xe0 ) == 0xc0 ) {		/* U+0x0080...U+0x07FF ?		*/
			b &= 0x1f;
			n = 1;

		} else if ( ( b & 0xf0 ) == 0xe0 ) {		/* U+0x0800...U+0xFFFF ?		*/
			b &= 0x0f;
			n = 2;

		} else {									/* ̑̃rbgzu	?		*/
			return ( 1 );
		}

		/* R[h擾					*/
		code = (uint16_t)b;
		while ( n-- ) {
			b = (uint8_t)*s++;
			if ( ( b & 0xc0 ) != 0x80 ) {			/* rbgzuG[?			*/
				return ( 2 );
			}
			code <<= 6;
			code |= (uint16_t)( b & 0x3f );
		}

		/* UNICODE->S-JISϊ			*/
		flashRead( uniTopAddress + ( (uint32_t)code * 2L ) ,&sjis ,2 );
		if ( sjis == 0 ) {
			return ( 2 );
		}

		/* SJISR[hi[					*/
		if ( sjis & 0xff00 ) {
			if ( bufferMax >= 2 ) {
				*d++ = (uint8_t)( ( sjis & 0xff00 ) >> 8 );
				*d++ = (uint8_t)sjis;
				bufferMax -= 2;
			} else {
				return ( 4 );
			}
		} else {
			if ( bufferMax >= 1 ) {
				*d++ = (uint8_t)sjis;
				bufferMax--;
			} else {
				return ( 5 );
			}
		}
	}

	/* NULLZbg		*/
	if ( bufferMax ) {
		*d++ = '\0';
	} else {
		return ( 7 );
	}

	return ( 0 );
}

/*****************************************************************************
*					UTF-16 -> S-JISϊ
* Fchar    *s         ͕
*		char    *d         ϊf[^̈
*		uint16_t bufferMax ϊf[^̈̃oCgTCY
*		uint8_t  mode      0:gGfBA !0:rbNGfBA
* ߒlFuint8_t            0: / !0:s
* R[h16rbgŒŏ
*****************************************************************************/
static uint8_t unicode_UTF16toSJIS( char *s ,char *d ,uint16_t bufferMax ,uint8_t mode )
{
	uint16_t code;
	uint16_t sjis;
	uint8_t c1 ,c2;

	while ( 1 ) {
	
		/* 16rbgR[h擾				*/
		c1 = *s++;
		c2 = *s++;

		/* 16rbgR[h擾				*/
		if ( mode ) {								/* rbNGfBA	*/
			code = (uint16_t)c1 << 8;
			code |= (uint16_t)c1;
		} else {									/* gGfBA	*/
			code = (uint16_t)c2 << 8;
			code |= (uint16_t)c1;
		}

		if ( code == 0x0000 ) {
			break;
		}

		/* UNICODE->S-JISϊ			*/
		flashRead( uniTopAddress + ( (uint32_t)code * 2L ) ,&sjis ,2 );
		if ( sjis == 0 ) {
			return ( 1 );
		}

		/* SJISR[hi[					*/
		if ( sjis & 0xff00 ) {
			if ( bufferMax >= 2 ) {
				*d++ = (uint8_t)( ( sjis & 0xff00 ) >> 8 );
				*d++ = (uint8_t)sjis;
				bufferMax -= 2;
			} else {
				return ( 2 );
			}
		} else {
			if ( bufferMax >= 1 ) {
				*d++ = (uint8_t)sjis;
				bufferMax--;
			} else {
				return ( 3 );
			}
		}
	}

	/* NULLZbg		*/
	if ( bufferMax ) {
		*d++ = '\0';
	} else {
		return ( 4 );
	}

	return ( 0 );
}
